$!      Scan disk devices and nertwork devices and create *_DISCOVERY.JSON files
$!
$!--
$ V = f$verify (0)
$ Set NoOn
$ if f$trnlnm ("ZABBIX_LOCAL_DIR") .eqs ""
$ Then 
$   Write Sys$Output "Logical Name ZABBIX_LOCAL_DIR  not defined."
$   Write Sys$Output "Execute ZABBIX_LOGICALS.COM procedure for defining ZABBIX Logicals names."
$   Exit 1
$ EndIf
$ File_1 = "ZABBIX_LOCAL_DIR:ZABBIX_SHAD_DISKS_DISCOVERY.JSON"
$ File_2 = "ZABBIX_LOCAL_DIR:ZABBIX_NOSHAD_DISKS_DISCOVERY.JSON"
$ File_3 = "ZABBIX_LOCAL_DIR:ZABBIX_IF_DISCOVERY.JSON"
$ File_4 = "ZABBIX_LOCAL_DIR:ZABBIX_BQUEUES_DISCOVERY.JSON"
$ File_5 = "ZABBIX_LOCAL_DIR:ZABBIX_PQUEUES_DISCOVERY.JSON"
$ File_6 = "ZABBIX_LOCAL_DIR:ZABBIX_SQUEUES_DISCOVERY.JSON"
$ 
$ Call OpenJSonFile "FDS" "''File_1'"
$ If .not. $Status Then Goto CommonExit
$
$ Call OpenJSonFile "FNS" "''File_2'"
$ If .not. $Status Then Goto ErrExit_1
$
$ DiskShad = 0
$ DiskAlon = 0
$ LineSHD = ""
$ LineALO = ""
$ScanDisks:
$ Device = f$device ("*","DISK") - "_"
$ If Device .eqs. "" Then Goto ScanDiskEnd
$ if f$getdvi (Device, "SHDW_MEMBER") Then Goto ScanDisks
$ if .NOT.f$getdvi (Device, "MNT") Then Goto Scandisks
$ if f$extract (0, 2, Device) .eqs. "DS"
$ Then
$   DiskShad = DiskShad + 1
$   MbrCnt = f$getdvi (Device, "SHDW_MBR_COUNT")
$   if LineSHD .nes. "" Then Write FDS LineSHD + ","
$   LineSHD = "{""{#DSNAME}"":""''Device'"", ""{#MCOUNT}"":""''MbrCnt'"""
$   LineSHD = LineSHD + ", ""{#DSPCFREE}"":10}"
$ Else
$   DiskAlon = DiskAlon + 1
$   if LineALO .nes "" Then Write FNS LineALO + ","
$   LineALO = "{""{#DNAME}"":""''Device'"""
$   LineALO = LineAlo +  ", ""{#DPCFREE}"":10}"
$ EndIf
$ Goto ScanDisks
$
$ScanDiskEnd:
$ If DiskShad .eqs. 0
$ Then
$   Close FDS /Disposition = Delete
$ Else
$   Write FDS LineSHD + "]"
$   Write FDS "}"
$   Close FDS
$   Write Sys$Output File_1 + " created with ''DiskShad' devices"
$ EndIf
$
$ If DiskAlon .eqs. 0
$ Then
$   Close FNS /Disposition = Delete
$ Else
$   Write FNS LineALO + "]"
$   Write FNS "}"
$   Close FNS
$   Write Sys$Output File_2 + " created with ''DiskAlon' devices"
$ EndIf
$
$ Call OpenJSonFile "FIF" "''File_3'"
$ If .not. $Status Then Goto CommonExit
$
$ LineNET = ""
$ NetDev = 0
$ScanNetDev:
$ Device = f$device ("*0:", "SCOM") - "_"
$ If Device .eqs. "" Then Goto ScanNetDevEnd
$ If f$getdvi ("''Device'","MBX") Then Goto ScanNetDev
$ If f$getdvi ("''Device'","REFCNT") .ne. 0 Then Goto ScanNetDev
$ NetDev = NetDev + 1
$ if LineNET .nes. "" Then Write FIF LineNET + ","
$ LineNET = "{""{#INAME}"":""''Device'""}"
$ Goto ScanNetDev
$
$ScanNetDevEnd:
$ Write FIF LineNET + "]"
$ Write FIF "}"
$ Close FIF
$ Write Sys$Output File_3 + " created with ''NetDev' devices"
$
$ Call OpenJSonFile "FQB" "''File_4'"
$ If .not. $Status Then Goto CommonExit
$
$ Call OpenJSonFile "FQP" "''File_5'"
$ If .not. $Status
$ Then
$   Close FQB /Disposition = Delete
$   Goto CommonExit
$ EndIf
$
$ Call OpenJSonFile "FQS" "''File_6'"
$ If .not. $Status
$ Then
$   Close FQB /Disposition = Delete
$   Close FQP /Disposition = Delete
$   Goto CommonExit
$ EndIf
$
$ LineBAT = ""
$ LinePRT = ""
$ LineSRV = ""
$ CntBAT = 0
$ CntPRT = 0
$ CntSRV = 0
$ Ctx = f$getqui ("Cancel_Operation")
$
$ScanQueue:
$ que = f$getqui ("DISPLAY_QUEUE","QUEUE_NAME","*")
$ if que .eqs. "" then goto ScanQueueEnd
$ prt = f$getqui ("DISPLAY_QUEUE","QUEUE_PRINTER","*","FREEZE_CONTEXT")
$ bat = f$getqui ("DISPLAY_QUEUE","QUEUE_BATCH","*","FREEZE_CONTEXT")
$ srv = f$getqui ("DISPLAY_QUEUE","QUEUE_SERVER","*","FREEZE_CONTEXT")
$ if prt
$ Then
$   CntPRT = CntPRT + 1
$   if LinePRT .nes. "" Then Write FQP LinePRT + ","
$   LinePRT = """{#QPNAME}"":""''Que'"", ""{#QPJOBPEND}"":""2""}"
$ EndIf
$ If bat
$ Then
$   CntBAT = CntBAT + 1
$   If LineBAT .nes. "" Then Write FQB LineBAT + ","
$   LineBAT = """{#QBNAME}"":""''Que'"", ""{#QBJOBPEND}"":""2""}"
$ EndIf
$ If srv
$ Then
$   CntSRV= CntSRV + 1
$   If LineSRV .nes. "" Then Write FQS LineSRV + ","
$   LineSRV = """{#QSNAME}"":""''Que'"", ""{#QSJOBPEND}"":""2""}"
$ EndIf
$ Goto ScanQueue
$
$ScanQueueEnd:
$ Write FQP LinePRT + "]"
$ Write FQP "}"
$ Close FQP
$ Write Sys$Output File_5 + " created with ''CntPRT' Printer Queues"
$ Write FQB LineBAT + "]"
$ Write FQB "}"
$ Write Sys$Output File_4 + " created with ''CntBAT' Batch Queues"
$ Close FQB
$ Write FQS LineSRV + "]"
$ Write FQS "}"
$ Close FQS
$ Write Sys$Output File_6 + " created with ''CntSRV' Server Queues"
$
$ Goto CommonExit
$
$ErrExit_1:
$ Close /Disposition = Delete FDS
$
$CommonExit:
$ V = f$verify (V)
$ Exit 1
$
$OpenJSonFile: SubRoutine
$ Open /Write /Error = ErrOpen 'P1' 'P2'
$ Write 'P1' "{"
$ Write 'P1' """data"":["
$ Exit 1
$
$ErrOpen:
$ Sts = $ Status
$ Write Sys$Output "Error opening ''P2' file"
$ Write Sys$Output "Message: ''f$message (Sts)'"
$ Exit 3
